## openimageio 1.6.11~dfsg0

=== CMakeLists.txt ===
project (OpenImageIO)

# Release version of the library
set (OIIO_VERSION_MAJOR 1)
set (OIIO_VERSION_MINOR 6)
set (OIIO_VERSION_PATCH 11)
set (OIIO_VERSION_RELEASE_TYPE "")   # "dev", "betaX", "RCY", ""

cmake_minimum_required (VERSION 2.6)
if (NOT CMAKE_VERSION VERSION_LESS 2.8.4)
    cmake_policy (SET CMP0017 NEW)
endif ()
if (NOT CMAKE_VERSION VERSION_LESS 3.0)
    cmake_policy (SET CMP0025 NEW)  # Detect AppleClang for new CMake
endif ()
if (NOT CMAKE_VERSION VERSION_LESS 3.2.2)
    cmake_policy (SET CMP0042 OLD)
    cmake_policy (SET CMP0046 OLD)
endif ()
set (CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

if (VERBOSE)
    message (STATUS "Project source dir = ${PROJECT_SOURCE_DIR}")
endif ()
message (STATUS "Project build dir = ${CMAKE_BINARY_DIR}")

if ("${PROJECT_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message (FATAL_ERROR "Not allowed to run in-source build!")
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "Release")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUGMODE ON)
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    # cmake bug workaround -- on some platforms, cmake doesn't set
    # NDEBUG for RelWithDebInfo mode
    add_definitions ("-DNDEBUG")
endif ()

option (CMAKE_USE_FOLDERS "Use the FOLDER target property to organize targets into folders." ON)
mark_as_advanced (CMAKE_USE_FOLDERS)
if (CMAKE_USE_FOLDERS)
    set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

## turn on more detailed warnings and consider warnings as errors
set (STOP_ON_WARNING ON CACHE BOOL "Stop building if there are any compiler warnings")
if (NOT MSVC)
    add_definitions ("-Wall")
    if (STOP_ON_WARNING)
        add_definitions ("-Werror")
    endif ()
endif ()

message (STATUS "CMAKE_CXX_COMPILER is ${CMAKE_CXX_COMPILER}")
message (STATUS "CMAKE_CXX_COMPILER_ID is ${CMAKE_CXX_COMPILER_ID}")

# Figure out which compiler we're using
if (CMAKE_COMPILER_IS_GNUCC)
    execute_process (COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
                     OUTPUT_VARIABLE GCC_VERSION
                     OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (VERBOSE)
        message (STATUS "Using gcc ${GCC_VERSION} as the compiler")
    endif ()
endif ()

# Figure out which compiler we're using, for tricky cases
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER MATCHES "[Cc]lang")
    # If using any flavor of clang, set CMAKE_COMPILER_IS_CLANG. If it's
    # Apple's variety, set CMAKE_COMPILER_IS_APPLECLANG and
    # APPLECLANG_VERSION_STRING, otherwise for generic clang set
    # CLANG_VERSION_STRING.
    set (CMAKE_COMPILER_IS_CLANG 1)
    EXECUTE_PROCESS( COMMAND ${CMAKE_CXX_COMPILER} --version OUTPUT_VARIABLE clang_full_version_string )
    if (clang_full_version_string MATCHES "Apple")
        set (CMAKE_CXX_COMPILER_ID "AppleClang")
        set (CMAKE_COMPILER_IS_APPLECLANG 1)
        string (REGEX REPLACE ".* version ([0-9]+\\.[0-9]+).*" "\\1" APPLECLANG_VERSION_STRING ${clang_full_version_string})
        if (VERBOSE)
            message (STATUS "The compiler is Clang: ${CMAKE_CXX_COMPILER_ID} version ${APPLECLANG_VERSION_STRING}")
        endif ()
    else ()
        string (REGEX REPLACE ".* version ([0-9]+\\.[0-9]+).*" "\\1" CLANG_VERSION_STRING ${clang_full_version_string})
        if (VERBOSE)
            message (STATUS "The compiler is Clang: ${CMAKE_CXX_COMPILER_ID} version ${CLANG_VERSION_STRING}")
        endif ()
    endif ()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set (CMAKE_COMPILER_IS_INTEL 1)
    if (VERBOSE)
        message (STATUS "Using Intel as the compiler")
    endif ()
endif ()

# Options common to gcc and clang
if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    # CMake doesn't automatically know what do do with
    # include_directories(SYSTEM...) when using clang or gcc.
    set (CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
    # Ensure this macro is set for stdint.h
    add_definitions ("-D__STDC_LIMIT_MACROS")
    add_definitions ("-D__STDC_CONSTANT_MACROS")
    # this allows native instructions to be used for sqrtf instead of a function call
    add_definitions ("-fno-math-errno")
    if (HIDE_SYMBOLS AND NOT DEBUGMODE)
        # Turn default symbol visibility to hidden
        set (VISIBILITY_COMMAND "-fvisibility=hidden -fvisibility-inlines-hidden")
        add_definitions (${VISIBILITY_COMMAND})
        if (CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "GNU")
            # Linux/FreeBSD/Hurd: also hide all the symbols of dependent
            # libraries to prevent clashes if an app using OIIO is linked
            # against other verions of our dependencies.
            set (VISIBILITY_MAP_COMMAND "-Wl,--version-script=${PROJECT_SOURCE_DIR}/src/libOpenImageIO/libOpenImageIO.map")
        endif ()
    endif ()
endif ()

# Clang-specific options
if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_APPLECLANG)
    # Disable some warnings for Clang, for some things that are too awkward
    # to change just for the sake of having no warnings.
    add_definitions ("-Wno-unused-function")
    add_definitions ("-Wno-overloaded-virtual")
    add_definitions ("-Wno-unneeded-internal-declaration")
    add_definitions ("-Wno-unused-private-field")
    add_definitions ("-Wno-tautological-compare")
    # disable warning about unused command line arguments
    add_definitions ("-Qunused-arguments")
    # Don't warn if we ask it not to warn about warnings it doesn't know
    add_definitions ("-Wunknown-warning-option")
    if (CLANG_VERSION_STRING VERSION_GREATER 3.5 OR
        APPLECLANG_VERSION_STRING VERSION_GREATER 6.1)
        add_definitions ("-Wno-unused-local-typedefs")
    endif ()
endif ()

# gcc specific options
if (CMAKE_COMPILER_IS_GNUCC AND NOT (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_APPLECLANG))
    if (NOT ${GCC_VERSION} VERSION_LESS 4.8)
        # suppress a warning that Boost::Python hits in g++ 4.8
        add_definitions ("-Wno-error=unused-local-typedefs")
        add_definitions ("-Wno-unused-local-typedefs")
    endif ()
    if (NOT ${GCC_VERSION} VERSION_LESS 4.5)
        add_definitions ("-Wno-unused-result")
    endif ()
    if (NOT ${GCC_VERSION} VERSION_LESS 6.0)
        add_definitions ("-Wno-error=misleading-indentation")
    endif ()
endif ()

# Try to detect if this is an OSX distro new enough that the system library
# is libc++.
if (EXISTS "/usr/lib/libc++.dylib")
    set (OSL_SYSTEM_HAS_LIBCPP ON)
endif ()


set (VERBOSE OFF CACHE BOOL "Print lots of messages while compiling")
set (EMBEDPLUGINS ON CACHE BOOL "Embed format plugins in libOpenImageIO")
set (OIIO_BUILD_TOOLS ON CACHE BOOL "Build the command-line tools")
set (OIIO_BUILD_TESTS ON CACHE BOOL "Build the unit tests")
set (BUILDSTATIC OFF CACHE BOOL "Build static library instead of shared")
set (LINKSTATIC OFF CACHE BOOL "Link with static external libraries when possible")
set (HIDE_SYMBOLS OFF CACHE BOOL "Hide symbols not in the public API")
set (USE_OPENGL ON CACHE BOOL "Include OpenGL support")
set (USE_QT ON CACHE BOOL "Include Qt support")
set (FORCE_OPENGL_1 OFF CACHE BOOL "Force iv to use OpenGL's fixed pipeline")
set (USE_PYTHON ON CACHE BOOL "Build the Python bindings")
set (USE_PYTHON3 OFF CACHE BOOL "Build the Python3 bindings")
set (USE_FIELD3D ON CACHE BOOL "Use Field3D if found")
set (USE_FFMPEG ON CACHE BOOL "Use FFmpeg if found")
set (USE_OPENJPEG ON CACHE BOOL "Use OpenJpeg if found")
set (USE_OCIO ON CACHE BOOL "Use OpenColorIO for color management if found")
set (USE_OPENCV ON CACHE BOOL "Use OpenCV if found")
set (USE_OPENSSL OFF CACHE BOOL "Use OpenSSL if found (for faster SHA-1)")
set (USE_FREETYPE ON CACHE BOOL "Use Freetype if found")
set (USE_GIF ON CACHE BOOL "Use GIF if found")
set (USE_PTEX ON CACHE BOOL "Use PTex if found")
set (USE_LIBRAW ON CACHE BOOL "Use LibRaw if found")
set (LIBRAW_PATH "" CACHE STRING "Custom LibRaw path")
set (NOTHREADS OFF CACHE BOOL "Compile with no threads or locking")
set (OIIO_THREAD_ALLOW_DCLP ON CACHE BOOL "OIIO threads may use DCLP for speed")
set (PYTHON_VERSION 2.6)
set (PYTHON3_VERSION 3.2)
set (USE_NUKE ON CACHE BOOL "Build Nuke plugins, if Nuke is found")
set (Nuke_ROOT "" CACHE STRING "Where to find Nuke installation")
set (NUKE_VERSION 7.0)
set (USE_EXTERNAL_PUGIXML OFF CACHE BOOL
     "Use an externally built shared library version of the pugixml library")
set (PUGIXML_HOME "" CACHE STRING "Hint about where to find external PugiXML library")

set (SOVERSION ${OIIO_VERSION_MAJOR}.${OIIO_VERSION_MINOR}
     CACHE STRING "Set the SO version in the SO name of the output library")

set (PYLIB_INCLUDE_SONAME OFF CACHE BOOL "If ON, soname/soversion will be set for Python module library")
set (PYLIB_LIB_PREFIX OFF CACHE BOOL "If ON, prefix the Python module with 'lib'")
set (BUILD_OIIOUTIL_ONLY OFF CACHE BOOL "If ON, will build *only* libOpenImageIO_Util")
set (OIIO_BUILD_CPP11 OFF CACHE BOOL "Compile in C++11 mode")
set (OIIO_BUILD_CPP14 OFF CACHE BOOL "Compile in C++14 mode")
set (OIIO_BUILD_LIBCPLUSPLUS OFF CACHE BOOL "Compile with clang libc++")
set (EXTRA_CPP_ARGS "" CACHE STRING "Extra C++ command line definitions")
set (USE_SIMD "" CACHE STRING "Use SIMD directives (0, sse2, sse3, ssse3, sse4.1, sse4.2)")
set (USE_CCACHE ON CACHE BOOL "Use ccache if found")

# Use ccache if found
find_program (CCACHE_FOUND ccache)
if (CCACHE_FOUND AND USE_CCACHE)
    if (CMAKE_COMPILER_IS_CLANG AND USE_QT AND (NOT DEFINED ENV{CCACHE_CPP2}))
        message (STATUS "Ignoring ccache because clang + Qt + env CCACHE_CPP2 is not set")
    else ()
        set_property (GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property (GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif ()
endif ()


if (BUILDSTATIC AND ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    # On Linux, the lack of -fPIC when building static libraries seems
    # incompatible with the dynamic library needed for the Python bindings.
    set (USE_PYTHON OFF)
    set (USE_PYTHON3 OFF)
endif()

if (NOTHREADS)
    message (STATUS "NO THREADS!")
    add_definitions ("-DNOTHREADS=1")
else ()
    if (VERBOSE)
        message (STATUS "Building with thread support")
        if (NOT OIIO_THREAD_ALLOW_DCLP)
            add_definitions ("-DOIIO_THREAD_ALLOW_DCLP=0")
        endif ()
    endif ()
endif ()

if (EXTRA_CPP_ARGS)
    message (STATUS "Extra C++ args: ${EXTRA_CPP_ARGS}")
    add_definitions ("${EXTRA_CPP_ARGS}")
endif()

if (OIIO_BUILD_CPP11 OR OIIO_BUILD_CPP14)
    if (OIIO_BUILD_CPP11)
        message (STATUS "Building for C++11")
        add_definitions ("-std=c++11")
    endif()
    if (OIIO_BUILD_CPP14)
        message (STATUS "Building for C++14")
        add_definitions ("-std=c++14")
    endif()
    if (CMAKE_COMPILER_IS_CLANG)
        # C++ >= 11 doesn't like 'register' keyword, which is in Qt headers
        add_definitions ("-Wno-deprecated-register")
    endif ()
endif ()

if (USE_LIBCPLUSPLUS AND CMAKE_COMPILER_IS_CLANG)
    message (STATUS "Using libc++")
    add_definitions ("-stdlib=libc++")
endif ()

if (NOT USE_SIMD STREQUAL "")
    message (STATUS "Compiling with SIMD level ${USE_SIMD}")
    if (USE_SIMD STREQUAL "0")
        add_definitions ("-DOIIO_NO_SSE=1")
    else ()
        string (REPLACE "," ";" SIMD_FEATURE_LIST ${USE_SIMD})
        foreach (feature ${SIMD_FEATURE_LIST})
            if (VERBOSE)
                message (STATUS "SIMD feature: ${feature}")
            endif ()
            if (MSVC OR CMAKE_COMPILER_IS_INTEL)
                add_definitions ("/arch:${feature}")
            else ()
                add_definitions ("-m${feature}")
            endif ()
        endforeach()
    endif ()
endif ()

# Set the default namespace
if (NOT OIIO_NAMESPACE)
    set (OIIO_NAMESPACE OpenImageIO CACHE STRING
         "Specify the master OpenImageIO C++ namespace: Options include OpenImageIO OpenImageIO_<YOURFACILITY> etc."
         FORCE)
endif ()
message(STATUS "Setting Namespace to: ${OIIO_NAMESPACE}")

set (CMAKE_MODULE_PATH

=== Makefile ===
#########################################################################
#
# This is the master makefile.
# Here we put all the top-level make targets, platform-independent
# rules, etc.
#
# Run 'make help' to list helpful targets.
#
#########################################################################


.PHONY: all debug profile clean realclean nuke doxygen

working_dir	:= ${shell pwd}
INSTALLDIR	=${working_dir}

# Figure out which architecture we're on
include ${working_dir}/src/make/detectplatform.mk

# Presence of make variables DEBUG and PROFILE cause us to make special
# builds, which we put in their own areas.
ifdef DEBUG
    variant +=.debug
endif
ifdef PROFILE
    variant +=.profile
endif

MY_MAKE_FLAGS ?=
MY_NINJA_FLAGS ?=
MY_CMAKE_FLAGS ?= -g3 -DSELF_CONTAINED_INSTALL_TREE:BOOL=TRUE
BUILDSENTINEL ?= Makefile
NINJA ?= ninja
CMAKE ?= cmake

# Site-specific build instructions
ifndef OPENIMAGEIO_SITE
    OPENIMAGEIO_SITE := ${shell uname -n}
endif
ifneq (${shell echo ${OPENIMAGEIO_SITE} | grep imageworks},)
include ${working_dir}/site/spi/Makefile-bits
endif

# Set up variables holding the names of platform-dependent directories --
# set these after evaluating site-specific instructions
top_build_dir := build
build_dir     := ${top_build_dir}/${platform}${variant}
top_dist_dir  := dist
dist_dir      := ${top_dist_dir}/${platform}${variant}

VERBOSE ?= ${SHOWCOMMANDS}
ifneq (${VERBOSE},)
MY_MAKE_FLAGS += VERBOSE=${VERBOSE}
MY_CMAKE_FLAGS += -DVERBOSE:BOOL=${VERBOSE}
ifneq (${VERBOSE},0)
	MY_NINJA_FLAGS += -v
	TEST_FLAGS += -V
endif
$(info OPENIMAGEIO_SITE = ${OPENIMAGEIO_SITE})
$(info dist_dir = ${dist_dir})
$(info INSTALLDIR = ${INSTALLDIR})
endif

ifneq (${EMBEDPLUGINS},)
MY_CMAKE_FLAGS += -DEMBEDPLUGINS:BOOL=${EMBEDPLUGINS}
endif

ifneq (${USE_OPENGL},)
MY_CMAKE_FLAGS += -DUSE_OPENGL:BOOL=${USE_OPENGL}
endif

ifneq (${USE_QT},)
MY_CMAKE_FLAGS += -DUSE_QT:BOOL=${USE_QT}
endif

ifneq (${FORCE_OPENGL_1},)
MY_CMAKE_FLAGS += -DFORCE_OPENGL_1:BOOL=${FORCE_OPENGL_1}
endif

ifneq (${NOTHREADS},)
MY_CMAKE_FLAGS += -DNOTHREADS:BOOL=${NOTHREADS}
endif

ifneq (${OIIO_THREAD_ALLOW_DCLP},)
MY_CMAKE_FLAGS += -DOIIO_THREAD_ALLOW_DCLP:BOOL=${OIIO_THREAD_ALLOW_DCLP}
endif

ifneq (${NAMESPACE},)
MY_CMAKE_FLAGS += -DOIIO_NAMESPACE:STRING=${NAMESPACE}
endif

ifneq (${HIDE_SYMBOLS},)
MY_CMAKE_FLAGS += -DHIDE_SYMBOLS:BOOL=${HIDE_SYMBOLS}
endif

ifneq (${USE_PYTHON},)
MY_CMAKE_FLAGS += -DUSE_PYTHON:BOOL=${USE_PYTHON}
endif

ifneq (${USE_PYTHON3},)
MY_CMAKE_FLAGS += -DUSE_PYTHON3:BOOL=${USE_PYTHON3}
endif

ifneq (${PYTHON_VERSION},)
MY_CMAKE_FLAGS += -DPYTHON_VERSION:STRING=${PYTHON_VERSION}
endif

ifneq (${USE_FFMPEG},)
MY_CMAKE_FLAGS += -DUSE_FFMPEG:BOOL=${USE_FFMPEG}
endif

ifneq (${USE_FIELD3D},)
MY_CMAKE_FLAGS += -DUSE_FIELD3D:BOOL=${USE_FIELD3D}
endif

ifneq (${FIELD3D_HOME},)
MY_CMAKE_FLAGS += -DFIELD3D_HOME:STRING=${FIELD3D_HOME}
endif

ifneq (${USE_OPENJPEG},)
MY_CMAKE_FLAGS += -DUSE_OPENJPEG:BOOL=${USE_OPENJPEG}
endif

ifneq (${USE_GIF},)
MY_CMAKE_FLAGS += -DUSE_GIF:BOOL=${USE_GIF}
endif

ifneq (${GIF_DIR},)
MY_CMAKE_FLAGS += -DGIF_DIR:STRING=${GIF_DIR}
endif

ifneq (${USE_OCIO},)
MY_CMAKE_FLAGS += -DUSE_OCIO:BOOL=${USE_OCIO}
endif

ifneq (${USE_NUKE},)
MY_CMAKE_FLAGS += -DUSE_NUKE:BOOL=${USE_NUKE}
endif

ifneq (${USE_OPENSSL},)
MY_CMAKE_FLAGS += -DUSE_OPENSSL:BOOL=${USE_OPENSSL}
endif

ifneq (${USE_OPENCV},)
MY_CMAKE_FLAGS += -DUSE_OPENCV:BOOL=${USE_OPENCV}
endif

ifneq (${USE_LIBRAW},)
MY_CMAKE_FLAGS += -DUSE_LIBRAW:BOOL=${USE_LIBRAW}
endif

ifneq (${LIBRAW_PATH},)
MY_CMAKE_FLAGS += -DLIBRAW_PATH:STRING=${LIBRAW_PATH}
endif

ifneq (${USE_PTEX},)
MY_CMAKE_FLAGS += -DUSE_PTEX:BOOL=${USE_PTEX}
endif

ifneq (${USE_EXTERNAL_PUGIXML},)
MY_CMAKE_FLAGS += -DUSE_EXTERNAL_PUGIXML:BOOL=${USE_EXTERNAL_PUGIXML} -DPUGIXML_HOME=${PUGIXML_HOME}
endif

ifneq (${OPENEXR_HOME},)
MY_CMAKE_FLAGS += -DOPENEXR_HOME:STRING=${OPENEXR_HOME}
endif

ifneq (${ILMBASE_HOME},)
MY_CMAKE_FLAGS += -DILMBASE_HOME:STRING=${ILMBASE_HOME}
endif

ifneq (${OCIO_HOME},)
MY_CMAKE_FLAGS += -DOCIO_PATH:STRING=${OCIO_HOME}
endif

ifneq (${BOOST_HOME},)
MY_CMAKE_FLAGS += -DBOOST_ROOT:STRING=${BOOST_HOME}
endif

ifneq (${NUKE_HOME},)
MY_CMAKE_FLAGS += -DNuke_ROOT:STRING=${NUKE_HOME}
endif

ifneq (${NUKE_VERSION},)
MY_CMAKE_FLAGS += -DNUKE_VERSION:STRING=${NUKE_VERSION}
endif

ifneq (${STOP_ON_WARNING},)
MY_CMAKE_FLAGS += -DSTOP_ON_WARNING:BOOL=${STOP_ON_WARNING}
endif

ifneq (${BUILDSTATIC},)
MY_CMAKE_FLAGS += -DBUILDSTATIC:BOOL=${BUILDSTATIC}
endif

ifneq (${LINKSTATIC},)
MY_CMAKE_FLAGS += -DLINKSTATIC:BOOL=${LINKSTATIC}
endif

ifneq (${OIIO_BUILD_TOOLS},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_TOOLS:BOOL=${OIIO_BUILD_TOOLS}
endif

ifneq (${OIIO_BUILD_TESTS},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_TESTS:BOOL=${OIIO_BUILD_TESTS}
endif

ifneq (${SOVERSION},)
MY_CMAKE_FLAGS += -DSOVERSION:STRING=${SOVERSION}
endif

ifneq (${PYLIB_LIB_PREFIX},)
MY_CMAKE_FLAGS += -DPYLIB_LIB_PREFIX:BOOL=${PYLIB_LIB_PREFIX}
endif

ifneq (${PYLIB_INCLUDE_SONAME},)
MY_CMAKE_FLAGS += -DPYLIB_INCLUDE_SONAME:BOOL=${PYLIB_INCLUDE_SONAME}
endif

ifneq (${BUILD_OIIOUTIL_ONLY},)
MY_CMAKE_FLAGS += -DBUILD_OIIOUTIL_ONLY:BOOL=${BUILD_OIIOUTIL_ONLY}
endif

ifdef DEBUG
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=Debug
endif

ifdef PROFILE
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo
endif

ifneq (${MYCC},)
MY_CMAKE_FLAGS += -DCMAKE_C_COMPILER:STRING="${MYCC}"
endif
ifneq (${MYCXX},)
MY_CMAKE_FLAGS += -DCMAKE_CXX_COMPILER:STRING="${MYCXX}"
endif

ifneq (${USE_CPP11},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_CPP11:BOOL=${USE_CPP11}
endif

ifneq (${USE_CPP14},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_CPP14:BOOL=${USE_CPP14}
endif

ifneq (${USE_LIBCPLUSPLUS},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_LIBCPLUSPLUS:BOOL=${USE_LIBCPLUSPLUS}
endif

ifneq (${EXTRA_CPP_ARGS},)
MY_CMAKE_FLAGS += -DEXTRA_CPP_ARGS:STRING="${EXTRA_CPP_ARGS}"
endif

ifneq (${USE_SIMD},)
MY_CMAKE_FLAGS += -DUSE_SIMD:STRING="${USE_SIMD}"
endif

ifneq (${TEST},)
TEST_FLAGS += -R ${TEST}
endif

ifneq (${USE_CCACHE},)
MY_CMAKE_FLAGS += -DUSE_CCACHE:BOOL=${USE_CCACHE}
endif

ifeq (${USE_NINJA},1)
MY_CMAKE_FLAGS += -G Ninja
BUILDSENTINEL := build.ninja
endif

#$(info MY_CMAKE_FLAGS = ${MY_CMAKE_FLAGS})
#$(info MY_MAKE_FLAGS = ${MY_MAKE_FLAGS})

#########################################################################




#########################################################################
# Top-level documented targets

all: dist

# 'make debug' is implemented via recursive make setting DEBUG
debug:
	${MAKE} DEBUG=1 --no-print-directory

# 'make profile' is implemented via recursive make setting PROFILE
profile:
	${MAKE} PROFILE=1 --no-print-directory

# 'make cmakesetup' constructs the build directory and runs 'cmake' there,
# generating makefiles to build the project.  For speed, it only does this when
# ${build_dir}/Makefile doesn't already exist, in which case we rely on the
# cmake generated makefiles to regenerate themselves when necessary.
cmakesetup:
	@ (if [ ! -e ${build_dir}/${BUILDSENTINEL} ] ; then \
		${CMAKE} -E make_directory ${build_dir} ; \
		cd ${build_dir} ; \
		${CMAKE} -DCMAKE_INSTALL_PREFIX=${INSTALLDIR}/${dist_dir} \
			${MY_CMAKE_FLAGS} -DBOOST_ROOT=${BOOST_HOME} \
			../.. ; \
	 fi)

ifeq (${USE_NINJA},1)

# 'make cmake' does a basic build (after first setting it up)
cmake: cmakesetup
	@ ( cd ${build_dir} ; ${NINJA} ${MY_NINJA_FLAGS} )

# 'make cmakeinstall' builds everthing and installs it in 'dist'.
# Suppress pointless output from docs installation.
cmakeinstall: cmake
	@ ( cd ${build_dir} ; ${NINJA} ${MY_NINJA_FLAGS} install | grep -v '^-- \(Installing\|Up-to-date\|Set runtime path\)' )

# 'make package' builds everything and then makes an installable package
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package: cmakeinstall
	@ ( cd ${build_dir} ; ${NINJA} ${MY_NINJA_FLAGS} package )

# 'make package_source' makes an installable source package
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package_source: cmakeinstall
	@ ( cd ${build_dir} ; ${NINJA} ${MY_NINJA_FLAGS} package_source )

else

# 'make cmake' does a basic build (after first setting it up)
cmake: cmakesetup
	@ ( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} )

# 'make cmakeinstall' builds everthing and installs it in 'dist'.
# Suppress pointless output from docs installation.
cmakeinstall: cmake
	@ ( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} install | grep -v '^-- \(Installing\|Up-to-date\|Set runtime path\)' )

# 'make package' builds everything and then makes an installable package
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package: cmakeinstall
	@ ( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package )

# 'make package_source' makes an installable source package
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package_source: cmakeinstall
	@ ( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package_source )

endif

# 'make dist' is just a synonym for 'make cmakeinstall'
dist : cmakeinstall

TEST_FLAGS += --force-new-ctest-process --output-on-failure

# 'make test' does a full build and then runs all tests
test: cmake
	${CMAKE} -E cmake_echo_color --switch=$(COLOR) --cyan "Running tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; PYTHONPATH=${PWD}/${build_dir}/src/python ctest  ${TEST_FLAGS} -E broken )

# 'make testall' does a full build and then runs all tests (even the ones
# that are expected to fail on some platforms)
testall: cmake
	${CMAKE} -E cmake_echo_color --switch=$(COLOR) --cyan "Running all tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; PYTHONPATH=${PWD}/${build_dir}/src/python ctest ${TEST_FLAGS} )

# 'make clean' clears out the build directory for this platform
clean:
	${CMAKE} -E remove_directory ${build_dir}

# 'make realclean' clears out both build and dist directories for this platform
realclean: clean
	${CMAKE} -E remove_directory ${dist_dir}

# 'make nuke' blows away the build and dist areas for all platforms
nuke:
	${CMAKE} -E remove_directory ${top_build_dir}
	${CMAKE} -E remove_directory ${top_dist_dir}

doxygen:
	doxygen src/doc/Doxyfile

#########################################################################



# 'make help' prints important make targets
help:
	@echo "Targets:"
	@echo "  make              Build optimized binaries and libraries in ${dist_dir},"
	@echo "                        temporary build files in ${build_dir}"
	@echo "  make debug        Build unoptimized with symbols in ${dist_dir}.debug,"
	@echo "                        temporary build files in ${build_dir}.debug"
	@echo "  make profile      Build for profiling in ${dist_dir}.profile,"
	@echo "                        temporary build files in ${build_dir}.profile"
	@echo "  make clean        Remove the temporary files in ${build_dir}"
	@echo "  make realclean    Remove both ${build_dir} AND ${dist_dir}"
	@echo "  make nuke         Remove ALL of build and dist (not just ${platform})"
	@echo "  make test         Run tests"
	@echo "  make testall      Run all tets, even broken ones"
	@echo "  make doxygen      Build the Doxygen docs in ${top_build_dir}/doxygen"
	@echo ""
	@echo "Helpful modifiers:"
	@echo "  C++ compiler and build process:"
	@echo "      VERBOSE=1                Show all compilation commands"
	@echo "      STOP_ON_WARNING=0        Do not stop building if compiler warns"
	@echo "      OPENIMAGEIO_SITE=xx      Use custom site build mods"
	@echo "      MYCC=xx MYCXX=yy         Use custom compilers"
	@echo "      USE_CPP11=1              Compile in C++11 mode"
	@echo "      USE_CPP14=1              Compile in C++14 mode"
	@echo "      USE_LIBCPLUSPLUS=1       Use clang libc++"
	@echo "      EXTRA_CPP_ARGS=          Additional args to the C++ command"
	@echo "      USE_NINJA=1              Set up Ninja build (instead of make)"
	@echo "      USE_CCACHE=0             Disable ccache (even if available)"
	@echo "  Linking and libraries:"
	@echo "      HIDE_SYMBOLS=1           Hide symbols not in the public API"

=== src/cineon.imageio/CMakeLists.txt ===
add_oiio_plugin (cineoninput.cpp cineonoutput.cpp
  libcineon/Cineon.cpp libcineon/OutStream.cpp libcineon/Codec.cpp libcineon/Reader.cpp
  libcineon/Writer.cpp libcineon/CineonHeader.cpp libcineon/ElementReadStream.cpp
  libcineon/InStream.cpp)

=== src/doc/Makefile ===
.PHONY: figures

include ../make/detectplatform.mk
ifeq (${OIIOTOOL},)
  ifneq (${shell ls ./../../build/${platform}/src/oiiotool/oiiotool},)
    OIIOTOOL := "../../../build/${platform}/src/oiiotool/oiiotool"
  else
    OIIOTOOL := "../../../build/src/oiiotool/oiiotool"
  endif
endif


PDFLATEX := pdflatex -halt-on-error -interaction=errorstopmode 

# by default, just make the document
all: openimageio.pdf


# document making rule: use pdflatex
openimageio.pdf: *.tex *.aux figures.turd
	${PDFLATEX} openimageio.tex


# special command 'make index' to regenerate the index
index: openimageio_index

openimageio_index: figures
	${PDFLATEX} openimageio.tex
	${PDFLATEX} openimageio.tex
	makeindex openimageio
	${PDFLATEX} openimageio.tex

figures:
	(cmake -E make_directory figures ; \
	 cd figures ; \
	 OIIOTOOL="${OIIOTOOL}" bash ../makefigures.bash ; \
	)

figures.turd: makefigures.bash
	${MAKE} figures
	touch figures.turd

cleanfigures:
	cmake -E remove_directory figures

=== src/dpx.imageio/CMakeLists.txt ===
add_oiio_plugin (dpxinput.cpp dpxoutput.cpp
  libdpx/DPX.cpp libdpx/OutStream.cpp libdpx/RunLengthEncoding.cpp
  libdpx/Codec.cpp libdpx/Reader.cpp libdpx/Writer.cpp libdpx/DPXHeader.cpp
  libdpx/ElementReadStream.cpp libdpx/InStream.cpp libdpx/DPXColorConverter.cpp)
target_link_libraries (dpx.imageio ${ILMBASE_LIBRARIES})

=== src/ffmpeg.imageio/CMakeLists.txt ===
if (USE_FFMPEG)
    if (FFMPEG_FOUND)
        include_directories (${FFMPEG_INCLUDE_DIR})
        add_oiio_plugin (ffmpeginput.cpp ffmpegoutput.cpp
                         LINK_LIBRARIES ${FFMPEG_LIBRARY}
                        )
    else()
        message (STATUS "FFmpeg not found: ffmpeg plugin will not be built")
    endif()
endif()

=== src/fonts/CMakeLists.txt ===
file (GLOB public_fonts "*/*.ttf")

if (INSTALL_FONTS AND USE_FREETYPE)
    install (FILES ${public_fonts} DESTINATION ${FONTS_INSTALL_DIR}
             COMPONENT fonts)
endif ()

=== src/gif.imageio/CMakeLists.txt ===
if (USE_GIF AND GIF_FOUND)
    include_directories (${GIF_INCLUDE_DIR})
    add_oiio_plugin (gifinput.cpp gifoutput.cpp LINK_LIBRARIES ${GIF_LIBRARIES})
endif()

=== src/idiff/CMakeLists.txt ===
set (idiff_srcs idiff.cpp)
add_executable (idiff ${idiff_srcs})
set_target_properties (idiff PROPERTIES FOLDER "Tools")
target_link_libraries (idiff OpenImageIO ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
oiio_install_targets (idiff)

=== src/include/CMakeLists.txt ===
file (GLOB public_headers OpenImageIO/*.h)

if (NOT USE_EXTERNAL_PUGIXML)
    list (APPEND public_headers
          OpenImageIO/pugixml.hpp
          OpenImageIO/pugiconfig.hpp
          OpenImageIO/pugixml.cpp)
endif ()

if (VERBOSE)
    message(STATUS "Create oiioversion.h from oiioversion.h.in")
endif ()
# Mangle the SOVERSION so that it's a valid C++ identifier for the versioning
# namespace defined in oiioversion.h
string (REGEX REPLACE "\\." "_" MANGLED_SOVERSION ${SOVERSION})
set (OIIO_VERSION_NS "v${MANGLED_SOVERSION}")
configure_file(OpenImageIO/oiioversion.h.in "${CMAKE_BINARY_DIR}/include/OpenImageIO/oiioversion.h" @ONLY)
list(APPEND public_headers "${CMAKE_BINARY_DIR}/include/OpenImageIO/oiioversion.h")

install (FILES ${public_headers} DESTINATION ${INCLUDE_INSTALL_DIR}
         COMPONENT developer)

=== src/iv/CMakeLists.txt ===
if (QT4_FOUND AND OPENGL_FOUND AND GLEW_FOUND)
    include (${QT_USE_FILE})
    include_directories (${QT_INCLUDES} ${OPENGL_INCLUDE_DIR} ${GLEW_INCLUDES})
    add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/src/iv/moc_imageviewer.cpp"
                        DEPENDS imageviewer.h imageviewer.cpp
                        COMMAND ${QT_MOC_EXECUTABLE}
                        ARGS "${PROJECT_SOURCE_DIR}/src/iv/imageviewer.h"
                           -o "${CMAKE_BINARY_DIR}/src/iv/moc_imageviewer.cpp"
                        )
    add_custom_command (OUTPUT ${CMAKE_BINARY_DIR}/src/iv/moc_ivgl.cpp
                        DEPENDS ivgl.h ivgl.cpp
                        COMMAND ${QT_MOC_EXECUTABLE}
                        ARGS "${PROJECT_SOURCE_DIR}/src/iv/ivgl.h"
                           -o "${CMAKE_BINARY_DIR}/src/iv/moc_ivgl.cpp"
                        )
    set (iv_srcs imageviewer.cpp ivimage.cpp ivgl.cpp ivinfowin.cpp 
                 ivpref.cpp ivmain.cpp moc_imageviewer.cpp moc_ivgl.cpp)
    if (FORCE_OPENGL_1)
        add_definitions(-DFORCE_OPENGL_1)
    endif()
    add_executable (iv ${iv_srcs})
    set_target_properties (iv PROPERTIES FOLDER "Tools")
    target_link_libraries (iv OpenImageIO ${QT_LIBRARIES} ${OPENGL_LIBRARIES} 
                               ${Boost_LIBRARIES} ${CMAKE_DL_LIBS}
                               ${GLEW_LIBRARIES})
    oiio_install_targets (iv)

else ()
    message (STATUS "\n\n   WARNING: Qt, OpenGL, or GLEW not found -- 'iv' will not be built!\n")
endif ()

=== src/jpeg.imageio/CMakeLists.txt ===
find_package (JPEG)
find_package (TIFF)

if (JPEG_FOUND AND TIFF_FOUND)
    include_directories (${TIFF_INCLUDE_DIR})
    include_directories (${JPEG_INCLUDE_DIR})
    add_oiio_plugin (jpeginput.cpp jpegoutput.cpp
        LINK_LIBRARIES ${JPEG_LIBRARIES})
endif ()

=== debian/changelog ===
openimageio (1.6.11~dfsg0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Mar 2016 14:14:22 +0100

openimageio (1.6.11~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 01 Mar 2016 10:55:56 +0100

openimageio (1.6.10~dfsg0-2ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Feb 2016 13:15:48 +0100

openimageio (1.6.10~dfsg0-2) unstable; urgency=medium

  * debian/control: Replaces/Breaks added to fix
    an upgrade issue on jessie -> stretch (Closes: #814525)

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 16 Feb 2016 10:41:26 +0100

openimageio (1.6.10~dfsg0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 11 Feb 2016 08:19:54 -0800

openimageio (1.6.10~dfsg0-1) unstable; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
      - 0003-Fix_types_on_32bit_platforms.patch dropped
      - 0004-Fix_specific_i386_issue.patch dropped
      (both were applied upstream)
  * debian/: new libopenimageio-doc binary package added
  * debian/control: S-V bump 3.9.6 -> 3.9.7 (no changes needed)
  * debian/copyright: entry added for Droid fonts

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 08 Feb 2016 21:10:40 +0100

openimageio (1.6.9~dfsg0-4ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Feb 2016 13:00:45 -0800

openimageio (1.6.9~dfsg0-4) unstable; urgency=medium

  * Upload to unstable
  * debian/control: git:// -> https:// Vcs-* fields updated

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 01 Feb 2016 15:09:49 +0100

openimageio (1.6.9~dfsg0-3) experimental; urgency=medium

  * debian/patches/: patchset updated
    - 0004-Fix_specific_i386_issue.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 21 Jan 2016 21:40:15 +0100

openimageio (1.6.9~dfsg0-2) experimental; urgency=medium

  * debian/patches/: patchset updated
    - 0003-Fix_types_on_32bit_platforms.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 15 Jan 2016 22:35:49 +0100

openimageio (1.6.9~dfsg0-1) experimental; urgency=medium

  * New upstream release (Closes: #808662)
    - debian/: SONAME bump 1.5 -> 1.6
    - debian/patches/: patchset refreshed against v1.6.9
      - 0002-Workaround_for_fonts_issue.patch updated
    - debian/copyright: .travis.yml entry added
  * debian/: python bindings support added (Closes: #801355)
  * debian/control: Vcs-Browser field updated
  * debian/rules: STOP_ON_WARNING=0 parameter added

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 11 Jan 2016 23:59:08 +0100

openimageio (1.5.23~dfsg0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Jan 2016 17:32:05 -0800

openimageio (1.5.23~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 06 Jan 2016 21:46:06 +0100

openimageio (1.5.22~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 17 Dec 2015 21:10:22 +0100

openimageio (1.5.21~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 15 Dec 2015 22:52:04 +0100

openimageio (1.5.20~dfsg0-1ubuntu2) xenial; urgency=medium

  * No-change rebuild against libglew1.13

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2015 19:25:07 +0000

openimageio (1.5.20~dfsg0-1ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - fix-build-without-iv.patch: Fix documentation build when building
      without iv.
    - debian/control: Disable iv build on armhf (by excluding that architecture
      from the libqt4-opengl-dev build-dependency), due to a GLfloat/GLdouble
      type conflict.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 26 Oct 2015 07:43:12 +0100

openimageio (1.5.20~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 07 Oct 2015 14:08:29 +0200

openimageio (1.5.19~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 24 Sep 2015 15:34:51 +0200

openimageio (1.5.18~dfsg0-1) unstable; urgency=medium

  * New upstream release
  * debian/: gcc-4.9/g++-4.9 support dropped (Closes: #794702)


=== debian/control ===
Source: openimageio
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 libboost-filesystem-dev,
 libboost-python-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libfreetype6-dev,
 libgif-dev,
 libglew-dev,
 libopencolorio-dev [!hurd-i386],
 libopencv-dev,
 libopenexr-dev,
 libopenjpeg-dev,
 libpng-dev,
 libqt4-opengl-dev [!armhf],
 libraw-dev,
 libtiff-dev,
 libwebp-dev,
 python-dev,
# documentation
 texlive-latex-base,
 fonts-freefont-ttf,
 latex2html,
 txt2man
Standards-Version: 3.9.7
Homepage: http://www.openimageio.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/openimageio.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/openimageio.git

Package: libopenimageio1.6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Library for reading and writing images - runtime
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains the runtime library for building programs that use
 libOpenImageIO.

Package: libopenimageio-dev
Section: libdevel
Architecture: any
Depends:
 libopenimageio1.6 (= ${binary:Version}),
 libopenimageio-doc (>= 1.6.10~dfsg0-1),
 ${misc:Depends}
Description: Library for reading and writing images - development
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains the static library and headers for building programs that
 use libOpenImageIO.

Package: openimageio-tools
Section: graphics
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Library for reading and writing images - command line tools
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains command line tools, including iv image viewer.

Package: python-openimageio
Section: python
Architecture: any
Depends: libopenimageio1.6 (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Description: Library for reading and writing images - Python bindings
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package provides Python bindings to the OpenImageIO library.

Package: libopenimageio-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: libopenimageio-dev (<< 1.6.10~dfsg0-1)
Breaks: libopenimageio-dev (<< 1.6.10~dfsg0-1)
Description: Library for reading and writing images - documentation
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS
export REPACK_SH=$(CURDIR)/debian/repack.sh

INSTDIR=debian/tmp

export DEB_LDFLAGS_MAINT_APPEND := -latomic

%:
	dh $@ --buildsystem=cmake \
		  --builddirectory=build \
		  --parallel \
		  --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH=ON \
		-DSTOP_ON_WARNING=OFF \
		-DUSE_FFMPEG=OFF \
		-DUSE_FIELD3D=OFF

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(CURDIR)/src/doc/

override_dh_auto_install:
	dh_auto_install \
		--buildsystem=cmake \
		--destdir=$(INSTDIR)

override_dh_auto_test:

override_dh_install:
	rm -f debian/tmp/usr/share/doc/openimageio/CHANGES
	rm -f debian/tmp/usr/share/doc/openimageio/LICENSE
	dh_install

get-orig-source:
	uscan --force-download
